unit test_013;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Math ;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Image1: TImage;
    Label2: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    LabelA: TLabel;
    Label3: TLabel;
    Edit7: TEdit;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    mx,my : integer ;
    cx,cy : integer ;
    procedure Revo(x1,y1,xc,yc,a:double;var x2,y2:double) ;
    procedure GamenInit ;
    procedure DispLine2(x1,y1,x2,y2:double);
    procedure DispCircle(x,y,r:double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{]ʑ}
{  x1,y1:wW}
{  xc,yc:]SW}
{  a@@:]px[rad]}
{  x2,y2:]̍W}
procedure TForm1.Revo(x1,y1,xc,yc,a:double;var x2,y2:double) ;
begin
  x2 := xc + (x1-xc)*Cos(a) - (y1-yc)*Sin(a) ;
  y2 := yc + (x1-xc)*Sin(a) + (y1-yc)*Cos(a) ;
end;

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   Edit1.Text := '';
   Edit2.Text := '';
   Edit3.Text := '';
   Edit4.Text := '';
   Edit5.Text := '';
   Edit6.Text := '';
   Edit7.Text := '';
   mx := Image1.Width;
   my := Image1.Height;
   cx := mx div 2 ;
   cy := my div 2 ;
   GamenInit ;
end;

// GAMEN INIT.
procedure TForm1.GamenInit ;
var
   i : integer ;
begin
   with Image1.Canvas do begin
      // ʃNA
      Pen.Mode  := pmCopy ;
      Pen.Width := 1 ;
      Pen.Color := clWhite ;
      Brush.Color := clWhite ;
      Brush.Style := bsSolid ;
		Rectangle(0,0,mx,my);
		Brush.Style := bsClear ;
      // ڐ
      Pen.Color := clAqua ;
      for i:=0 to (mx div 10) do begin
         MoveTo(i*10,cy-3);
         LineTo(i*10,cy+3);
      end;
      for i:=0 to (my div 10) do begin
         MoveTo(cx-3,i*10);
         LineTo(cx+3,i*10);
      end;
      // 
      Pen.Color := clBlue ;
      MoveTo(0,cy);
      LineTo(mx,cy);
      MoveTo(cx,0);
      LineTo(cx,my);
   end;
end;

// PLOT
procedure TForm1.Button1Click(Sender: TObject);
var
   ax1,ay1,ax2,ay2,bx,by,br : double ;
   ang : double ;
   bx1,by1,d : double ;
   xx1,xx2 : double ;
   x1,y1,x2,y2 : double ;
begin
   ax1 := StrToFloat(Edit1.Text);
   ay1 := StrToFloat(Edit2.Text);
   ax2 := StrToFloat(Edit3.Text);
   ay2 := StrToFloat(Edit4.Text);
   bx  := StrToFloat(Edit5.Text);
   by  := StrToFloat(Edit6.Text);
   br  := StrToFloat(Edit7.Text);

   GamenInit ;
   with Image1.Canvas do begin
      Pen.Color := clBlack; DispLine2(ax1,ay1,ax2,ay2);
      Pen.Color := clGreen; DispCircle(bx,by,br);
   end;

   ang := ArcTan2((ay2-ay1),(ax2-ax1));   // ̌Xpx[rad]
   Revo(bx,by,ax1,ay1,-ang,bx1,by1);   // ~S_t]
   d := Abs(by1-ay1);                  // ~S_ƒ̋
   if (d > br) then begin
      LabelA.Caption := '_͂܂';
      exit;
   end;
   xx1 := bx1-sqrt(br*br-d*d);
   Revo(xx1,ay1,ax1,ay1,ang,x1,y1);    // ]
   if (d = br) then begin
      LabelA.Caption := 'P_F'+FloatToStr(x1)+'C'+FloatToStr(y1);
   end
   else begin
      xx2 := bx1+sqrt(br*br-d*d);
      Revo(xx2,ay1,ax1,ay1,ang,x2,y2); // ]
      LabelA.Caption := 'Q_F'+FloatToStr(x1)+'C'+FloatToStr(y1)
                             +'@'+FloatToStr(x2)+'C'+FloatToStr(y2);
   end;

   // _Ɂ}
   with Image1.Canvas do begin
      Pen.Color := clRed ;
      Ellipse(cx+Trunc(x1*10)-3,cy-Trunc(y1*10)-3,
              cx+Trunc(x1*10)+3,cy-Trunc(y1*10)+3);
      if (d < br) then
         Ellipse(cx+Trunc(x2*10)-3,cy-Trunc(y2*10)-3,
                 cx+Trunc(x2*10)+3,cy-Trunc(y2*10)+3);
   end;
end;

// }
procedure TForm1.DispLine2(x1,y1,x2,y2:double);
begin
   with Image1.Canvas do begin
      MoveTo(cx+Trunc(x1*10),cy-Trunc(y1*10));
      LineTo(cx+Trunc(x2*10),cy-Trunc(y2*10));
   end;
end;

// ~}
procedure TForm1.DispCircle(x,y,r:double);
begin
   with Image1.Canvas do begin
      Ellipse(cx+Trunc((x-r)*10),cy-Trunc((y-r)*10),
              cx+Trunc((x+r)*10),cy-Trunc((y+r)*10));
   end;
end;

end.
